<?php
/*
*	CurrencyConverter Component for Joomla! 1.5.x
* @version $Id: config.currencyconverter2.php - v1.0.2 - 2008/07/22 - D-Mack Media
* @package Joomla
* @subpackage CurrencyConverter
* @copyright (c) 2007-2010 D-Mack Media, dmackmedia.com
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
* This is free software
*/

defined( '_JEXEC' ) or die( 'Restricted access' );
global $mainframe, $option;

$main_livesite    = JURI::base()."components".DS.$option.DS;

$valueinputfield  = '<input name="val" type="text" size="10" />
<input type="hidden" name="path" id="path" value="'.$main_livesite.'" />';

$result           = '<div id="result"> </div>';
$result1          = '<input type="hidden" name="result1text" id="result1text" value="'.$result1text.'" />';
$result2          = '<input type="hidden" name="result2text" id="result2text" value="'.$result2text.'" />';
$submitbutton     = '<input name="submit" type="button" value="{submitbuttontext}" onclick="showDataInput()" />';

$CountryArray   = array();
$CountryArray[] = array('country_id'=>'ALL', 'country'=>'Albanian Lek (ALL)');
$CountryArray[] = array('country_id'=>'DZD', 'country'=>'Algerian Dinar (DZD)');
$CountryArray[] = array('country_id'=>'XAL', 'country'=>'Aluminium Ounces (XAL)');
$CountryArray[] = array('country_id'=>'ARS', 'country'=>'Argentine Peso (ARS)');
$CountryArray[] = array('country_id'=>'AWG', 'country'=>'Aruba Florin (AWG)');
$CountryArray[] = array('country_id'=>'AUD', 'country'=>'Australian Dollar (AUD)');
$CountryArray[] = array('country_id'=>'BSD', 'country'=>'Bahamian Dollar (BSD)');
$CountryArray[] = array('country_id'=>'BHD', 'country'=>'Bahraini Dinar (BHD)');
$CountryArray[] = array('country_id'=>'BDT', 'country'=>'Bangladesh Taka (BDT)');
$CountryArray[] = array('country_id'=>'BBD', 'country'=>'Barbados Dollar (BBD)');
$CountryArray[] = array('country_id'=>'BYR', 'country'=>'Belarus Ruble (BYR)');
$CountryArray[] = array('country_id'=>'BZD', 'country'=>'Belize Dollar (BZD)');
$CountryArray[] = array('country_id'=>'BMD', 'country'=>'Bermuda Dollar (BMD)');
$CountryArray[] = array('country_id'=>'BTN', 'country'=>'Bhutan Ngultrum (BTN)');
$CountryArray[] = array('country_id'=>'BOB', 'country'=>'Bolivian Boliviano (BOB)');
$CountryArray[] = array('country_id'=>'BWP', 'country'=>'Botswana Pula (BWP)');
$CountryArray[] = array('country_id'=>'BRL', 'country'=>'Brazilian Real (BRL)');
$CountryArray[] = array('country_id'=>'GBP', 'country'=>'British Pound (GBP)');
$CountryArray[] = array('country_id'=>'BND', 'country'=>'Brunei Dollar (BND)');
$CountryArray[] = array('country_id'=>'BGN', 'country'=>'Bulgarian Lev (BGN)');
$CountryArray[] = array('country_id'=>'BIF', 'country'=>'Burundi Franc (BIF)');
$CountryArray[] = array('country_id'=>'KHR', 'country'=>'Cambodia Riel (KHR)');
$CountryArray[] = array('country_id'=>'CAD', 'country'=>'Canadian Dollar (CAD)');
$CountryArray[] = array('country_id'=>'CVE', 'country'=>'Cape Verde Escudo (CVE)');
$CountryArray[] = array('country_id'=>'KYD', 'country'=>'Cayman Islands Dollar (KYD)');
$CountryArray[] = array('country_id'=>'XOF', 'country'=>'CFA Franc (BCEAO) (XOF)');
$CountryArray[] = array('country_id'=>'XAF', 'country'=>'CFA Franc (BEAC) (XAF)');
$CountryArray[] = array('country_id'=>'CLP', 'country'=>'Chilean Peso (CLP)');
$CountryArray[] = array('country_id'=>'CNY', 'country'=>'Chinese Yuan (CNY)');
$CountryArray[] = array('country_id'=>'COP', 'country'=>'Colombian Peso (COP)');
$CountryArray[] = array('country_id'=>'KMF', 'country'=>'Comoros Franc (KMF)');
$CountryArray[] = array('country_id'=>'XCP', 'country'=>'Copper Pounds (XCP)');
$CountryArray[] = array('country_id'=>'CRC', 'country'=>'Costa Rica Colon (CRC)');
$CountryArray[] = array('country_id'=>'HRK', 'country'=>'Croatian Kuna (HRK)');
$CountryArray[] = array('country_id'=>'CUP', 'country'=>'Cuban Peso (CUP)');
$CountryArray[] = array('country_id'=>'CYP', 'country'=>'Cyprus Pound (CYP)');
$CountryArray[] = array('country_id'=>'CZK', 'country'=>'Czech Koruna (CZK)');
$CountryArray[] = array('country_id'=>'DKK', 'country'=>'Danish Krone (DKK)');
$CountryArray[] = array('country_id'=>'DJF', 'country'=>'Dijibouti Franc (DJF)');
$CountryArray[] = array('country_id'=>'DOP', 'country'=>'Dominican Peso (DOP)');
$CountryArray[] = array('country_id'=>'XCD', 'country'=>'East Caribbean Dollar (XCD)');
$CountryArray[] = array('country_id'=>'ECS', 'country'=>'Ecuador Sucre (ECS)');
$CountryArray[] = array('country_id'=>'EGP', 'country'=>'Egyptian Pound (EGP)');
$CountryArray[] = array('country_id'=>'SVC', 'country'=>'El Salvador Colon (SVC)');
$CountryArray[] = array('country_id'=>'ERN', 'country'=>'Eritrea Nakfa (ERN)');
$CountryArray[] = array('country_id'=>'EEK', 'country'=>'Estonian Kroon (EEK)');
$CountryArray[] = array('country_id'=>'ETB', 'country'=>'Ethiopian Birr (ETB)');
$CountryArray[] = array('country_id'=>'EUR', 'country'=>'Euro (EUR)');
$CountryArray[] = array('country_id'=>'FKP', 'country'=>'Falkland Islands Pound (FKP)');
$CountryArray[] = array('country_id'=>'FJD', 'country'=>'Fiji Dollar (FJD)');
$CountryArray[] = array('country_id'=>'GMD', 'country'=>'Gambian Dalasi (GMD)');
$CountryArray[] = array('country_id'=>'GHC', 'country'=>'Ghanian Cedi (GHC)');
$CountryArray[] = array('country_id'=>'GIP', 'country'=>'Gibraltar Pound (GIP)');
$CountryArray[] = array('country_id'=>'XAU', 'country'=>'Gold Ounces (XAU)');
$CountryArray[] = array('country_id'=>'GTQ', 'country'=>'Guatemala Quetzal (GTQ)');
$CountryArray[] = array('country_id'=>'GNF', 'country'=>'Guinea Franc (GNF)');
$CountryArray[] = array('country_id'=>'GYD', 'country'=>'Guyana Dollar (GYD)');
$CountryArray[] = array('country_id'=>'HTG', 'country'=>'Haiti Gourde (HTG)');
$CountryArray[] = array('country_id'=>'HNL', 'country'=>'Honduras Lempira (HNL)');
$CountryArray[] = array('country_id'=>'HKD', 'country'=>'Hong Kong Dollar (HKD)');
$CountryArray[] = array('country_id'=>'HUF', 'country'=>'Hungarian Forint (HUF)');
$CountryArray[] = array('country_id'=>'ISK', 'country'=>'Iceland Krona (ISK)');
$CountryArray[] = array('country_id'=>'INR', 'country'=>'Indian Rupee (INR)');
$CountryArray[] = array('country_id'=>'IDR', 'country'=>'Indonesian Rupiah (IDR)');
$CountryArray[] = array('country_id'=>'IRR', 'country'=>'Iran Rial (IRR)');
$CountryArray[] = array('country_id'=>'IQD', 'country'=>'Iraqi Dinar (IQD)');
$CountryArray[] = array('country_id'=>'ILS', 'country'=>'Israeli Shekel (ILS)');
$CountryArray[] = array('country_id'=>'JMD', 'country'=>'Jamaican Dollar (JMD)');
$CountryArray[] = array('country_id'=>'JPY', 'country'=>'Japanese Yen (JPY)');
$CountryArray[] = array('country_id'=>'JOD', 'country'=>'Jordanian Dinar (JOD)');
$CountryArray[] = array('country_id'=>'KZT', 'country'=>'Kazakhstan Tenge (KZT)');
$CountryArray[] = array('country_id'=>'KES', 'country'=>'Kenyan Shilling (KES)');
$CountryArray[] = array('country_id'=>'KRW', 'country'=>'Korean Won (KRW)');
$CountryArray[] = array('country_id'=>'KWD', 'country'=>'Kuwaiti Dinar (KWD)');
$CountryArray[] = array('country_id'=>'LAK', 'country'=>'Lao Kip (LAK)');
$CountryArray[] = array('country_id'=>'LVL', 'country'=>'Latvian Lat (LVL)');
$CountryArray[] = array('country_id'=>'LBP', 'country'=>'Lebanese Pound (LBP)');
$CountryArray[] = array('country_id'=>'LSL', 'country'=>'Lesotho Loti (LSL)');
$CountryArray[] = array('country_id'=>'LRD', 'country'=>'Liberian Dollar (LRD)');
$CountryArray[] = array('country_id'=>'LYD', 'country'=>'Libyan Dinar (LYD)');
$CountryArray[] = array('country_id'=>'LTL', 'country'=>'Lithuanian Lita (LTL)');
$CountryArray[] = array('country_id'=>'MOP', 'country'=>'Macau Pataca (MOP)');
$CountryArray[] = array('country_id'=>'MKD', 'country'=>'Macedonian Denar (MKD)');
$CountryArray[] = array('country_id'=>'MWK', 'country'=>'Malawi Kwacha (MWK)');
$CountryArray[] = array('country_id'=>'MYR', 'country'=>'Malaysian Ringgit (MYR)');
$CountryArray[] = array('country_id'=>'MVR', 'country'=>'Maldives Rufiyaa (MVR)');
$CountryArray[] = array('country_id'=>'MTL', 'country'=>'Maltese Lira (MTL)');
$CountryArray[] = array('country_id'=>'MRO', 'country'=>'Mauritania Ougulya (MRO)');
$CountryArray[] = array('country_id'=>'MUR', 'country'=>'Mauritius Rupee (MUR)');
$CountryArray[] = array('country_id'=>'MXN', 'country'=>'Mexican Peso (MXN)');
$CountryArray[] = array('country_id'=>'MDL', 'country'=>'Moldovan Leu (MDL)');
$CountryArray[] = array('country_id'=>'MNT', 'country'=>'Mongolian Tugrik (MNT)');
$CountryArray[] = array('country_id'=>'MAD', 'country'=>'Moroccan Dirham (MAD)');
$CountryArray[] = array('country_id'=>'MMK', 'country'=>'Myanmar Kyat (MMK)');
$CountryArray[] = array('country_id'=>'NAD', 'country'=>'Namibian Dollar (NAD)');
$CountryArray[] = array('country_id'=>'NPR', 'country'=>'Nepalese Rupee (NPR)');
$CountryArray[] = array('country_id'=>'ANG', 'country'=>'Neth Antilles Guilder (ANG)');
$CountryArray[] = array('country_id'=>'TRY', 'country'=>'New Turkish Lira (TRY)');
$CountryArray[] = array('country_id'=>'NZD', 'country'=>'New Zealand Dollar (NZD)');
$CountryArray[] = array('country_id'=>'NIO', 'country'=>'Nicaragua Cordoba (NIO)');
$CountryArray[] = array('country_id'=>'NGN', 'country'=>'Nigerian Naira (NGN)');
$CountryArray[] = array('country_id'=>'KPW', 'country'=>'North Korean Won (KPW)');
$CountryArray[] = array('country_id'=>'NOK', 'country'=>'Norwegian Krone (NOK)');
$CountryArray[] = array('country_id'=>'OMR', 'country'=>'Omani Rial (OMR)');
$CountryArray[] = array('country_id'=>'XPF', 'country'=>'Pacific Franc (XPF)');
$CountryArray[] = array('country_id'=>'PKR', 'country'=>'Pakistani Rupee (PKR)');
$CountryArray[] = array('country_id'=>'XPD', 'country'=>'Palladium Ounces (XPD)');
$CountryArray[] = array('country_id'=>'PAB', 'country'=>'Panama Balboa (PAB)');
$CountryArray[] = array('country_id'=>'PGK', 'country'=>'Papua New Guinea Kina (PGK)');
$CountryArray[] = array('country_id'=>'PYG', 'country'=>'Paraguayan Guarani (PYG)');
$CountryArray[] = array('country_id'=>'PEN', 'country'=>'Peruvian Nuevo Sol (PEN)');
$CountryArray[] = array('country_id'=>'PHP', 'country'=>'Philippine Peso (PHP)');
$CountryArray[] = array('country_id'=>'XPT', 'country'=>'Platinum Ounces (XPT)');
$CountryArray[] = array('country_id'=>'PLN', 'country'=>'Polish Zloty (PLN)');
$CountryArray[] = array('country_id'=>'QAR', 'country'=>'Qatar Rial (QAR)');
$CountryArray[] = array('country_id'=>'RON', 'country'=>'Romanian New Leu (RON)');
$CountryArray[] = array('country_id'=>'RUB', 'country'=>'Russian Rouble (RUB)');
$CountryArray[] = array('country_id'=>'RWF', 'country'=>'Rwanda Franc (RWF)');
$CountryArray[] = array('country_id'=>'WST', 'country'=>'Samoa Tala (WST)');
$CountryArray[] = array('country_id'=>'STD', 'country'=>'Sao Tome Dobra (STD)');
$CountryArray[] = array('country_id'=>'SAR', 'country'=>'Saudi Arabian Riyal (SAR)');
$CountryArray[] = array('country_id'=>'SCR', 'country'=>'Seychelles Rupee (SCR)');
$CountryArray[] = array('country_id'=>'SLL', 'country'=>'Sierra Leone Leone (SLL)');
$CountryArray[] = array('country_id'=>'XAG', 'country'=>'Silver Ounces (XAG)');
$CountryArray[] = array('country_id'=>'SGD', 'country'=>'Singapore Dollar (SGD)');
$CountryArray[] = array('country_id'=>'SKK', 'country'=>'Slovak Koruna (SKK)');
$CountryArray[] = array('country_id'=>'SIT', 'country'=>'Slovenian Tolar (SIT)');
$CountryArray[] = array('country_id'=>'SBD', 'country'=>'Solomon Islands Dollar (SBD)');
$CountryArray[] = array('country_id'=>'SOS', 'country'=>'Somali Shilling (SOS)');
$CountryArray[] = array('country_id'=>'ZAR', 'country'=>'South African Rand (ZAR)');
$CountryArray[] = array('country_id'=>'LKR', 'country'=>'Sri Lanka Rupee (LKR)');
$CountryArray[] = array('country_id'=>'SHP', 'country'=>'St Helena Pound (SHP)');
$CountryArray[] = array('country_id'=>'SDD', 'country'=>'Sudanese Dinar (SDD)');
$CountryArray[] = array('country_id'=>'SZL', 'country'=>'Swaziland Lilageni (SZL)');
$CountryArray[] = array('country_id'=>'SEK', 'country'=>'Swedish Krona (SEK)');
$CountryArray[] = array('country_id'=>'CHF', 'country'=>'Swiss Franc (CHF)');
$CountryArray[] = array('country_id'=>'SYP', 'country'=>'Syrian Pound (SYP)');
$CountryArray[] = array('country_id'=>'TWD', 'country'=>'Taiwan Dollar (TWD)');
$CountryArray[] = array('country_id'=>'TZS', 'country'=>'Tanzanian Shilling (TZS)');
$CountryArray[] = array('country_id'=>'THB', 'country'=>'Thai Baht (THB)');
$CountryArray[] = array('country_id'=>'TOP', 'country'=>'Tonga Paanga (TOP)');
$CountryArray[] = array('country_id'=>'TTD', 'country'=>'Trinidad-Tobago Dollar (TTD)');
$CountryArray[] = array('country_id'=>'TND', 'country'=>'Tunisian Dinar (TND)');
$CountryArray[] = array('country_id'=>'USD', 'country'=>'U.S. Dollar (USD)');
$CountryArray[] = array('country_id'=>'AED', 'country'=>'UAE Dirham (AED)');
$CountryArray[] = array('country_id'=>'UGX', 'country'=>'Ugandan Shilling (UGX)');
$CountryArray[] = array('country_id'=>'UAH', 'country'=>'Ukraine Hryvnia (UAH)');
$CountryArray[] = array('country_id'=>'UYU', 'country'=>'Uruguayan New Peso (UYU)');
$CountryArray[] = array('country_id'=>'VUV', 'country'=>'Vanuatu Vatu (VUV)');
$CountryArray[] = array('country_id'=>'VEB', 'country'=>'Venezuelan Bolivar (VEB)');
$CountryArray[] = array('country_id'=>'VND', 'country'=>'Vietnam Dong (VND)');
$CountryArray[] = array('country_id'=>'YER', 'country'=>'Yemen Riyal (YER)');
$CountryArray[] = array('country_id'=>'ZMK', 'country'=>'Zambian Kwacha (ZMK)');
$CountryArray[] = array('country_id'=>'ZWD', 'country'=>'Zimbabwe Dollar (ZWD)');

$fromselectdropdownfield = '
  <script type="text/javascript">
  function FromOption() {
    var FromSel = document.getElementById("cur_from");
    var FromHidden = document.getElementById("fromselected");
    FromHidden.value = FromSel.options[FromSel.selectedIndex].value;
     return true;
  }
  </script>
  <select name="cur_from" id="cur_from" onchange="FromOption();">
';
foreach($CountryArray as $index=>$value){
  if ($value["country_id"] == $fromselected) {
    $fromselectdropdownfield .= '<option value="'.$value["country_id"].'" selected="selected">'.$value["country"].'</option>';
  } else {
    $fromselectdropdownfield .= '<option value="'.$value["country_id"].'">'.$value["country"].'</option>';
  }
}
$fromselectdropdownfield .= '
  </select>
  <input type="hidden" name="fromselected" id="fromselected" value="'.$fromselected.'" />
';

$toselectdropdownfield = '
  <script type="text/javascript">
  function ToOption() {
    var ToSel = document.getElementById("cur_to");
    var ToHidden = document.getElementById("toselected");
    ToHidden.value = ToSel.options[ToSel.selectedIndex].value;
     return true;
  }
  </script>
  <select name="cur_to" id="cur_to" onchange="ToOption();">
';
foreach($CountryArray as $index=>$value){
  if ($value["country_id"] == $toselected) {
    $toselectdropdownfield .= '<option value="'.$value["country_id"].'" selected="selected">'.$value["country"].'</option>';
  } else {
    $toselectdropdownfield .= '<option value="'.$value["country_id"].'">'.$value["country"].'</option>';
  }
}
$toselectdropdownfield .= '
  </select>
  <input type="hidden" name="toselected" id="toselected" value="'.$toselected.'" />
';
?>