<?php
/**
	* @copyright Copyright (C) 2006 - 2008 JoomlaShine.com
	* @author JoomlaShine.com
	* @license Creative Commons Attribution-Share Alike 3.0 Unported License
	* Please visit http://www.joomlashine.com for more information
*/

// no direct access
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<!-- Free Joomla! template by JoomlaShine.com - JSN Epic Free 2.0 for Joomla! 1.0.x -->
<html xmlns="http://www.w3.org/1999/xhtml" lang="<?php echo _LANGUAGE; ?>" xml:lang="<?php echo _LANGUAGE; ?>">
<head>
<meta http-equiv="Content-Type" content="text/html; <?php echo _ISO; ?>" />
<?php
	if ( $my->id ) {
		initEditor();
	}
	mosShowHead();

	require($mosConfig_absolute_path."/templates/" . $mainframe->getTemplate() . "/php/jsn_utils.php");

	/****************************************************************/
	/* TEMPLATE PARAMETERS */

	/* Overal template width specified in pixels (for fixed width) or percentage (for fluid width). */
	$template_width = "960px";

	/* Path to logo image starting from the Joomla! root folder (! without preceding slash !). */
	$logo_path = "templates/jsn_epic_free/images/logo.png";

	/* Logo width specified in pixels. */
	$logo_width = "250px";

	/* Logo height specified in pixels. */
	$logo_height = "75px";

	/* URL where logo image should link to (! without preceding slash !). */
	$logo_link = "index.php";

	/* Definition whether to enable PNG fix feature for IE6 or not.
	   This parameter should be turned off only when there are incompatibility issues. */
	$enable_pngfix = "yes"; // yes | no


	/****************************************************************/

	/* Private use only */
	$template_path = $mosConfig_live_site."/templates/".$mainframe->getTemplate();
	$has_right = mosCountModules('right');
	$has_left = mosCountModules('left');

	$logo_image = $mosConfig_live_site."/".$logo_path;
	$logo_text = $mosConfig_sitename;

	// Parameter filter
	$template_width = intval($template_width);
	$template_width .= ($template_width < 100)?"%":"px";
	$logo_width = intval($logo_width)."px";
	$logo_height = intval($logo_height)."px";
	$logo_link = ($logo_link != "")?$mosConfig_live_site."/".$logo_link:"";
?>
<link href="<?php echo $template_path; ?>/css/template_css.css" rel="stylesheet" type="text/css" media="screen" />
<?php

	// Inline CSS styles for template layout
	echo '<style type="text/css">';

	// Setup template width parameter
	echo '
	#jsn-page {
		width: '.$template_width.';
	}
	';

	// Adjustment of header area according to the logo height parameter
	echo '
	#jsn-header {
		height: '.$logo_height.';
	}
	';

	// Setup width of content area
	$tw = 100;
	if ($has_left) {
		$tw -= 23;
		echo '
	#jsn-content_inner1 {
		background: transparent url('.$template_path.'/images/leftside-bg-full.png) repeat-y 23% top;
		padding: 0;
	}
	#jsn-maincontent_inner {
		padding-left: 0;
	}
	';
	}

	if ($has_right) {
		$tw -= 23;
		echo '
	#jsn-content_inner2 {
		background: transparent url('.$template_path.'/images/rightside-bg-full.png) repeat-y 77% top;
		padding: 0;
	}
	#jsn-maincontent_inner {
		padding-right: 0;
	}
	';
	}
	if(intval($template_width) < 100) {
		$tws = ($tw - 0.1).'%';
	}else{
		$tws = floor($tw*0.01*intval($template_width)).'px';
	}
	echo '
	#jsn-leftsidecontent {
		float: left;
		width: 23%;
	}
	#jsn-maincontent {
		float: left;
		width: '.$tws.';
	}
	#jsn-rightsidecontent {
		float: right;
		width: 23%;
	}
	';
	
	echo '</style>';

	// Setup core javascript library
	echo '<script type="text/javascript" src="'.$template_path.'/js/jsn_script.js"></script>';
	
?>
<!--[if lte IE 6]>
<link href="<?php echo $template_path; ?>/css/jsn_fixie6.css" rel="stylesheet" type="text/css" />
<?php if($enable_pngfix == "yes") {?>
<script type="text/javascript">
	var blankImg = '<?php echo $mosConfig_live_site; ?>/images/blank.png';
</script>
<style type="text/css">
	img {  behavior: url(<?php echo $template_path;?>/js/iepngfix.htc); }
</style>
<?php } ?>
<![endif]-->
<!--[if lte IE 7]>
<script type="text/javascript" src="<?php echo $template_path; ?>/js/suckerfish.js"></script>
<![endif]-->
<!--[if IE 7]>
<link href="<?php echo $template_path; ?>/css/jsn_fixie7.css" rel="stylesheet" type="text/css" />
<![endif]-->
</head>
<body id="jsn-master">
	<div id="jsn-page">
		<div id="jsn-header">
			<div id="jsn-logo"><?php if ($logo_link != "") echo '<a href="'.$logo_link.'" title="'.$logo_text.'">'; ?><img src="<?php echo $logo_image;?>" width="<?php echo intval($logo_width); ?>" height="<?php echo intval($logo_height); ?>" alt="<?php echo $logo_text; ?>" /><?php if ($logo_link != "") echo '</a>'; ?></div>
			<?php if (mosCountModules( 'top' ) > 0) { ?>
			<div id="jsn-ptop"><?php mosLoadModules('top', -2); ?></div>
			<?php } ?>
		</div>
		<div id="jsn-body">
			<?php if (jsnCountPositions(array('toolbar', 'inset'))) { ?>
			<div id="jsn-mainmenu">
				<?php if (mosCountModules( 'toolbar' ) > 0) { ?>
				<div id="jsn-ptoolbar"><?php mosLoadModules('toolbar', -2); ?></div>
				<?php } ?>
				<?php if (mosCountModules( 'inset' ) > 0) { ?>
				<div id="jsn-pinset"><?php mosLoadModules('inset', -2); ?></div>
				<?php } ?>
			</div>
			<?php } ?>
			<?php if (mosCountModules( 'header' ) > 0) { ?>
			<div id="jsn-promo">
				<div id="jsn-pheader" class="jsn-column"><?php mosLoadModules('header', -2); ?></div>
			</div>
			<?php } ?>
			<div id="jsn-content"><div id="jsn-content_inner1"><div id="jsn-content_inner2">
				<?php if (mosCountModules( 'left' ) > 0) { ?>
				<div id="jsn-leftsidecontent" class="jsn-column">
					<div id="jsn-pleft"><?php mosLoadModules('left', -3); ?></div>
				</div>
				<?php } ?>
				<div id="jsn-maincontent" class="jsn-column"><div id="jsn-maincontent_inner">
					<div id="jsn-pathway"><?php mosPathWay(); ?></div>
					<?php
						$positionCount = jsnCountPositions(array('user1', 'user2'));
						if($positionCount){
							$grid_suffix = "_grid".$positionCount;
					?>
					<div id="jsn-usermodules1"><div id="jsn-usermodules1_inner<?php echo $grid_suffix; ?>">
						<?php if (mosCountModules( 'user1' ) > 0) { ?>
						<div id="jsn-puser1<?php echo $grid_suffix; ?>" class="jsn-column"><div id="jsn-puser1"><?php mosLoadModules('user1', -2); ?></div></div>
						<?php } ?>
						<?php if (mosCountModules( 'user2' ) > 0) { ?>
						<div id="jsn-puser2<?php echo $grid_suffix; ?>" class="jsn-column"><div id="jsn-puser2"><?php mosLoadModules('user2', -2); ?></div></div>
						<?php } ?>
						<div class="clearbreak"></div>
					</div></div>
					<?php } ?>
					<div id="jsn-mainbody">
						<?php mosMainBody(); ?>
					</div>
					<?php
					$positionCount = jsnCountPositions(array('user3', 'user4'));
					if($positionCount){
						$grid_suffix = "_grid".$positionCount;
					?>
					<div id="jsn-usermodules2"><div id="jsn-usermodules2_inner<?php echo $grid_suffix; ?>">
						<?php if (mosCountModules( 'user3' ) > 0) { ?>
						<div id="jsn-puser3<?php echo $grid_suffix; ?>" class="jsn-column"><div id="jsn-puser3"><?php mosLoadModules('user3', -2); ?></div></div>
						<?php } ?>
						<?php if (mosCountModules( 'user4' ) > 0) { ?>
						<div id="jsn-puser4<?php echo $grid_suffix; ?>" class="jsn-column"><div id="jsn-puser4"><?php mosLoadModules('user4', -2); ?></div></div>
						<?php } ?>
						<div class="clearbreak"></div>
					</div></div>
					<?php } ?>
					<?php if (mosCountModules( 'banner' ) > 0) { ?>
					<div id="jsn-banner"><?php mosLoadModules('banner', -2); ?></div>
					<?php } ?>
				</div></div>
				<?php if (mosCountModules( 'right' ) > 0) { ?>
				<div id="jsn-rightsidecontent" class="jsn-column">
					<div id="jsn-pright"><?php mosLoadModules('right', -3); ?></div>
				</div>
				<?php } ?>
				<div class="clearbreak"></div>
			</div></div></div>
			<?php
			$positionCount = jsnCountPositions(array('user5', 'user6', 'user7'));
			if($positionCount){
				$grid_suffix = "_grid".$positionCount;
			?>
			<div id="jsn-usermodules3"><div id="jsn-usermodules3_inner<?php echo $grid_suffix; ?>">
				<?php if (mosCountModules( 'user5' ) > 0) { ?>
				<div id="jsn-puser5<?php echo $grid_suffix; ?>" class="jsn-column"><div id="jsn-puser5"><?php mosLoadModules('user5', -2); ?></div></div>
				<?php } ?>
				<?php if (mosCountModules( 'user6' ) > 0) { ?>
				<div id="jsn-puser6<?php echo $grid_suffix; ?>" class="jsn-column"><div id="jsn-puser6"><?php mosLoadModules('user6', -2); ?></div></div>
				<?php } ?>
				<?php if (mosCountModules( 'user7' ) > 0) { ?>
				<div id="jsn-puser7<?php echo $grid_suffix; ?>" class="jsn-column"><div id="jsn-puser7"><?php mosLoadModules('user7', -2); ?></div></div>
				<?php } ?>
				<div class="clearbreak"></div>
			</div></div>
			<?php } ?>
		</div>
		<?php
			$positionCount = jsnCountPositions(array('footer', 'bottom'));
			if($positionCount){
				$grid_suffix = "_grid".$positionCount;
		?>
		<div id="jsn-footer">
			<?php if (mosCountModules( 'footer' ) > 0) { ?>
			<div id="jsn-pfooter<?php echo $grid_suffix; ?>" class="jsn-column"><div id="jsn-pfooter"><?php mosLoadModules('footer', -2); ?></div></div>
			<?php } ?>
			<?php if (mosCountModules( 'bottom' ) > 0) { ?>
			<div id="jsn-pbottom<?php echo $grid_suffix; ?>" class="jsn-column"><div id="jsn-pbottom"><?php mosLoadModules('bottom', -2); ?></div></div>
			<?php } ?>
			<div class="clearbreak"></div>
		</div>
		<?php } ?>
	</div>
	<?php
		/*** REMOVAL OR MODIFICATION COPYRIGHT TEXT BELLOW IS VIOLATION OF JOOMLASHINE.COM TERMS & CONDITIONS AND DEPRIVES OF ANY KIND OF SUPPORTS ***/
		$copyright_text = '<div id="jsn-copyright"><a href="http://www.joomlashine.com" title="Free Joomla Templates">Free Joomla Templates</a> by JoomlaShine.com</div>';
		echo $copyright_text;
	?>
	<?php mosLoadModules('debug', -2); ?>
	<?php include($mosConfig_absolute_path."/templates/".$mainframe->getTemplate()."/php/jsn_debug.php"); ?>
</body>
</html>